package org.appfuse.webapp.action.fileupload.util;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.upload.FormFile;

import java.io.*;

public class UploadUtil {
    protected transient static Log log = LogFactory.getLog(UploadUtil.class);

    public static void writeToDisk(FormFile file, String fileName, String destinationPath) throws FileNotFoundException, IOException {

        log.info("[writeToDisk] - Entering Fuction");
        InputStream stream = null;
        OutputStream bos = null;
        int bytesRead = 0;
        int fileSize = 0;
        byte[] buffer = null;

        log.info("[writeToDisk] - Get InputFileStream and FileOutputStream");
        stream = file.getInputStream();
        //Fix path
        if(destinationPath.endsWith("\\")||destinationPath.endsWith("/")) {
        } else {
          destinationPath += File.pathSeparator;
        }
        bos = new FileOutputStream(destinationPath + fileName);

        fileSize = file.getFileSize();
        log.info("[writeToDisk] - Got File Size of " + fileSize + " bytes");

        bytesRead = 0;
        buffer = new byte[fileSize];
        while ((bytesRead = stream.read(buffer, 0, fileSize)) != -1) {
            bos.write(buffer, 0, bytesRead);
        }
        log.info("[writeToDisk] - Finished writing file(" + fileName + ") of size (" + fileSize + ") to disk (" + destinationPath + ").");

        bos.close();
        stream.close();
    }
}
